stages:
  - build
  - deployment

default:
  image:
    name: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/python:3.10
    entrypoint:
      - /usr/bin/env
      - "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin"

variables:
  PIP_CACHE_DIR: $CI_PROJECT_DIR/.cache/pip
  AWS_DEFAULT_REGION: eu-west-1

build:
  stage: build
  script:
    - python -m venv venv
    - source ./venv/bin/activate
    - pip3 install -r requirements.txt
    - python -V
  artifacts:
    paths:
      - venv/

serverless-deploy-dev:
  image: ${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/nikolaik/python-nodejs:python3.10-nodejs18
  stage: deployment
  when: manual
  script:
    - npm install -g serverless
    - serverless --version
    - serverless plugin install -n serverless-python-requirements --stage dev
    - serverless plugin install -n serverless-plugin-utils --stage dev
    - serverless plugin install -n serverless-step-functions --stage dev
    - serverless plugin install -n serverless-deployment-bucket --stage dev
    - serverless deploy --stage dev --verbose
